%define pkg     python
%define ver     2.6.9
%define maj     %(echo %{ver} | cut -d'.' -f1)
%define min     %(echo %{ver} | cut -d'.' -f2)
%define pkg_str %{pkg}%{maj}%{min}
%define abi_ver %{maj}.%{min}

%define pylib   %{_libdir}/%{pkg}%{abi_ver}
%define dynlib  %{pylib}/lib-dynload
%define sitepkg %{pylib}/site-packages
%define tools   %{pylib}/Tools
%define demo    %{pylib}/Demo
%define tkinter tkinter%{maj}%{min}

%define _pyconfig32_h pyconfig-32.h
%define _pyconfig64_h pyconfig-64.h

%ifarch x86_64
%define _pyconfig_h %{_pyconfig64_h}
%else
%define _pyconfig_h %{_pyconfig32_h}
%endif

%define __python_provides %{SOURCE2} --provides
%define __python_requires %{SOURCE2} --requires

# Don't run brp-python-bytecompile to prevent wrong Python ABI (2.4)
%define __os_install_post \
    /usr/lib/rpm/redhat/brp-compress \
    %{!?__debug_package:/usr/lib/rpm/redhat/brp-strip %{__strip}} \
    /usr/lib/rpm/redhat/brp-strip-static-archive %{__strip} \
    /usr/lib/rpm/redhat/brp-strip-comment-note %{__strip} %{__objdump} \
%{nil}


Summary:        An interpreted, object-oriented programming language
Name:           %{pkg_str}
Version:        %{ver}
Release:        2%{?dist}%{?pext}
License:        Python
Group:          Development/Languages
Source0:        http://legacy.%{pkg}.org/ftp/%{pkg}/%{ver}/Python-%{ver}.tgz
Source1:        %{pkg}-brp.sh
Source2:        %{pkg}-deps.sh
Source3:        %{pkg}-rpm.macros
Patch0:         %{pkg}-2.6.9-config.patch
Patch1:         %{pkg}-2.6.9-build.patch
Patch2:         %{pkg}-2.6.9-arch64.patch
Patch3:         %{pkg}-2.6.9-fixes.patch
Patch4:         %{pkg}-2.6.9-noexecmem.patch
URL:            http://www.%{pkg}.org/
Buildroot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:         Python Software Foundation
Provides:       python-abi = %{abi_ver}
Provides:       python(abi) = %{abi_ver}
Requires:       %{name}-libs = %{version}-%{release}
BuildRequires:  bzip2-devel db4-devel gdbm-devel zlib-devel
BuildRequires:  ncurses-devel openssl-devel readline-devel
BuildRequires:  sqlite-devel gmp-devel libtermcap-devel
BuildRequires:  libX11-devel

%description
Python is an interpreted, interactive, object-oriented programming
language often compared to Tcl, Perl, Scheme or Java. It includes
modules, classes, exceptions, very high level dynamic data types
and dynamic typing. Python supports interfaces to many system calls
and libraries, as well as to various windowing systems (X11, Motif,
Tk, Mac and MFC).


%package        devel
Summary:        Libraries and header files for Python development
Group:          Development/Libraries
Requires:       %{name}-libs = %{version}-%{release}
Requires:       pkgconfig

%description    devel
The %{name}-devel package contains the header files and libraries
needed to extended the Python programming language's interpreter
with dynamically loaded extensions and for embedding Python into
other programs.


%package        libs
Summary:        The runtime libraries for Python
Group:          System Environment/Libraries
Obsoletes:      %{name}-lib < %{version}-%{release}

%description    libs
The %{name}-libs package contains the runtime libraries of Python
for applications which uses Python as embedded scripting language.


%package        static
Summary:        The static libraries for Python
Group:          Development/Libraries
Requires:       %{name}-devel = %{version}-%{release}

%description    static
The %{name}-static package contains the statically linkable libraries
for Python.


%package        test
Summary:        Test modules from Python
Group:          Development/Languages
Requires:       %{name} = %{version}-%{release}

%description    test
The %{name}-test package contains test modules from the main Python
package.


%package        tools
Summary:        Development tools for Python
Group:          Development/Tools
Requires:       %{name} = %{version}-%{release}
Requires:       %{tkinter} = %{version}-%{release}
Obsoletes:      %{name}-tool < %{version}-%{release}

%description    tools
The %{name}-tools package contains several tools to support development
of Python programs, including IDLE (an IDE with editing and debugging
facilities), a color editor (pynche), and a python gettext program
(pygettext.py).


%package     -n %{tkinter}
Summary:        A graphical user interface for Python
Group:          Development/Languages
Requires:       %{name} = %{version}-%{release}
BuildRequires:  tcl tcl-devel tk tk-devel tix-devel

%description -n %{tkinter}
The %{tkinter} package contains the Tkinter (Tk interface) program, an
graphical user interface for the Python scripting language.


%prep
%setup -q -n Python-%{ver}
%patch0 -p1
%patch1 -p1
%patch3 -p1
%patch4 -p1
%ifarch x86_64
%patch2 -p1
%endif


%build
%configure \
	CC="%{__cc}"                                 \
	LINKCC="%{__cc}"                             \
	CFLAGS=                                      \
	CXX="%{__cxx}"                               \
	CXXFLAGS=                                    \
	OPT="${RPM_OPT_FLAGS} -D_GNU_SOURCE -fwrapv" \
	--enable-shared                              \
	--enable-ipv6                                \
	--enable-unicode                             \
	--without-cxx-main                           \
	--with-signal-module                         \
	--with-threads

%{__make} %{?_smp_mflags}

# Fix path and rebuild with new Python
%{__ln_s} -f %{pkg} %{pkg}%{abi_ver}

TOPDIR="%{_builddir}/%{buildsubdir}"
LD_LIBRARY_PATH="${TOPDIR}" \
	"${TOPDIR}/%{pkg}" Tools/scripts/pathfix.py -i "%{_bindir}/env %{pkg}%{abi_ver}" .
LD_LIBRARY_PATH="${TOPDIR}" PATH="${PATH}:${TOPDIR}" \
	%{__make} %{?_smp_mflags}


%check
EXTRATESTOPTS="-x test_distutils test_dl test_file test_socket test_urllib2" \
	%{__make} test


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sysconfdir}/rpm
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_prefix}/lib/{%{pkg}%{abi_ver}/site-packages,rpm}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{sitepkg}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{tools}/scripts
%{__mkdir_p} ${RPM_BUILD_ROOT}%{demo}

%{__make} \
	DESTDIR=${RPM_BUILD_ROOT} \
	install

%{__install} -m 0644 lib*.a     ${RPM_BUILD_ROOT}%{_libdir}

%{__install} -m 0755 %{SOURCE1} ${RPM_BUILD_ROOT}%{_prefix}/lib/rpm/brp-multiple-python-bytecompile
%{__install} -m 0755 %{SOURCE2} ${RPM_BUILD_ROOT}%{_prefix}/lib/rpm/pythonmultideps.sh
%{__install} -m 0644 %{SOURCE3} ${RPM_BUILD_ROOT}%{_sysconfdir}/rpm/macros.%{pkg}%{maj}%{min}

# Install tools
%{__cat} << \_EOF_ >${RPM_BUILD_ROOT}%{_bindir}/modulator
#!%{_bindir}/env bash
exec %{sitepkg}/modulator/modulator.py
_EOF_

%{__cat} << \_EOF_ >${RPM_BUILD_ROOT}%{_bindir}/pynche
#!%{_bindir}/env bash
exec %{sitepkg}/pynche/pynche
_EOF_

%{__chmod} 0755                   ${RPM_BUILD_ROOT}%{_bindir}/modulator
%{__chmod} 0755                   ${RPM_BUILD_ROOT}%{_bindir}/pynche

pushd Tools
%{__cp}      -r modulator         ${RPM_BUILD_ROOT}%{sitepkg}
%{__mv}      -f modulator/README  modulator/README.modulator

%{__cp}      -r pynche            ${RPM_BUILD_ROOT}%{sitepkg}
%{__mv}      -f pynche/README     pynche/README.pynche

pushd i18n
%{__install} -m 0755 msgfmt.py    ${RPM_BUILD_ROOT}%{_bindir}
%{__install} -m 0755 pygettext.py ${RPM_BUILD_ROOT}%{_bindir}
popd

%{__install} -m 0644 README       ${RPM_BUILD_ROOT}%{tools}
%{__install} -m 0644 scripts/*.py ${RPM_BUILD_ROOT}%{tools}/scripts
popd

%{__cp}      -ar Demo/*           ${RPM_BUILD_ROOT}%{demo}

# Prevent conflicts with main Python
pushd ${RPM_BUILD_ROOT}%{_bindir}
for FILE in %{pkg} idle modulator pynche pydoc; do
  %{__mv} -f ${FILE}     ${FILE}%{maj}%{min}
done
for FILE in msgfmt pygettext smtpd; do
  %{__mv} -f ${FILE}.py  ${FILE}%{maj}%{min}.py
done

%{__mv} -f 2to3          2to3_%{maj}%{min}
popd

pushd ${RPM_BUILD_ROOT}%{_mandir}
%{__mv} -f man1/%{pkg}.1 man1/%{pkg}%{maj}%{min}.1
popd

# Prepare multilib support
pushd ${RPM_BUILD_ROOT}%{_includedir}/%{pkg}%{abi_ver}
%{__mv} -f pyconfig.h %{_pyconfig_h}

%{__cat} << \_EOF_ >pyconfig.h
#include <bits/wordsize.h>

#if __WORDSIZE == 32
#include "%{_pyconfig32_h}"
#elif __WORDSIZE == 64
#include "%{_pyconfig64_h}"
#else
#error "Unknown word size"
#endif
_EOF_
popd

%{__ln_s} -f ../../lib%{pkg}%{abi_ver}.so ${RPM_BUILD_ROOT}%{pylib}/config
%{__sed} -i -e "s/'pyconfig.h'/'%{_pyconfig_h}'/" \
	${RPM_BUILD_ROOT}%{pylib}/distutils/sysconfig.py

# Fix interpreter path
for FILE in %{_bindir}/pydoc%{maj}%{min} %{sitepkg}/pynche/pynche    \
	    %{pylib}/whichdb.py %{pylib}/Demo/pdist/{rcvs,rrcs,rcsbump}; do
  %{__sed} -i -e 's,#.*[/ ]python$,#!%{_bindir}/env %{pkg}%{abi_ver},' \
	${RPM_BUILD_ROOT}${FILE}
done

## Fix permissions
find ${RPM_BUILD_ROOT} -type f -perm 0555     -exec %{__chmod} 0755 {} \;
find ${RPM_BUILD_ROOT} -type f -name "*.xbm"  -exec %{__chmod} a-x  {} \;
find ${RPM_BUILD_ROOT} -type f -name "*.xpm*" -exec %{__chmod} a-x  {} \;

find ${RPM_BUILD_ROOT} -type f -name "*.py" ! -perm /u+x,g+x,o+x \
	-exec %{__sed} -e '/^#!/Q 0' -e 'Q 1' {} \; -print       \
	-exec %{__sed} -i '1d' {} \;
find ${RPM_BUILD_ROOT} -type f -name "*.py" -perm /u+x,g+x,o+x   \
	! -exec %{__grep} -m 1 -q '^#!' {} \;                    \
	-exec %{__chmod} a-x {} \;

%{__chmod} a-x ${RPM_BUILD_ROOT}%{pylib}/Demo/comparisons/patterns
%{__chmod} a-x ${RPM_BUILD_ROOT}%{pylib}/Demo/md5test/foo
%{__chmod} a-x ${RPM_BUILD_ROOT}%{pylib}/Demo/rpc/test
%{__chmod} a-x ${RPM_BUILD_ROOT}%{pylib}/Demo/scripts/newslist.doc
%{__chmod} a-x ${RPM_BUILD_ROOT}%{pylib}/Tools/README

# Cleanup
find ${RPM_BUILD_ROOT} -type f -name "*.bat" -exec %{__rm} -f {} \;
find ${RPM_BUILD_ROOT} -type f -name "*.pyw" -exec %{__rm} -f {} \;
find ${RPM_BUILD_ROOT} -type f -name "*.au"  -exec %{__rm} -f {} \;
find ${RPM_BUILD_ROOT} -type f -name "*~"    -exec %{__rm} -f {} \;

%{__rm} -f ${RPM_BUILD_ROOT}%{_bindir}/%{pkg}-config
%{__rm} -f ${RPM_BUILD_ROOT}%{pylib}/{LICENSE.txt,idlelib/testcode.py*}
%{__rm} -f ${RPM_BUILD_ROOT}%{sitepkg}/modulator/Templates/copyright
%{__rm} -f ${RPM_BUILD_ROOT}%{_libdir}/lib*.so.?


%post libs -p /sbin/ldconfig


%postun libs -p /sbin/ldconfig


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc LICENSE README
%doc Misc/{ACKS,NEWS,cheatsheet}
%config(noreplace) %{_sysconfdir}/rpm/macros.%{pkg}%{maj}%{min}
%{_bindir}/pydoc*
%{_bindir}/%{pkg}%{abi_ver}
%{_bindir}/%{pkg}%{maj}%{min}
%dir %{_includedir}/%{pkg}%{abi_ver}
%{_includedir}/%{pkg}%{abi_ver}/%{_pyconfig_h}
%dir %{pylib}
%{pylib}/*.py*
%{pylib}/*.doc
%{pylib}/bsddb
%{pylib}/compiler
%dir %{pylib}/config
%{pylib}/config/Makefile
%{pylib}/ctypes
%{pylib}/curses
%{pylib}/distutils
%{pylib}/email
%{pylib}/encodings
%{pylib}/hotshot
%{pylib}/idlelib
%{pylib}/json
%{pylib}/lib2to3
%{pylib}/logging
%{pylib}/multiprocessing
%{pylib}/plat-linux2
%{pylib}/sqlite3
%dir %{pylib}/test
%{pylib}/test/__init__.py*
%{pylib}/test/test_support.py*
%{pylib}/wsgiref.egg-info
%{pylib}/wsgiref
%{pylib}/xml
%dir %{dynlib}
%{dynlib}/Python-%{ver}-py%{abi_ver}.egg-info
%{dynlib}/_bisectmodule.so
%{dynlib}/_bsddb.so
%{dynlib}/_bytesio.so
%{dynlib}/_codecs_cn.so
%{dynlib}/_codecs_hk.so
%{dynlib}/_codecs_iso2022.so
%{dynlib}/_codecs_jp.so
%{dynlib}/_codecs_kr.so
%{dynlib}/_codecs_tw.so
%{dynlib}/_collectionsmodule.so
%{dynlib}/_csv.so
%{dynlib}/_ctypes.so
%{dynlib}/_curses.so
%{dynlib}/_curses_panel.so
%{dynlib}/_elementtree.so
%{dynlib}/_fileio.so
%{dynlib}/_functoolsmodule.so
%{dynlib}/_hashlib.so
%{dynlib}/_heapq.so
%{dynlib}/_hotshot.so
%{dynlib}/_json.so
%{dynlib}/_localemodule.so
%{dynlib}/_lsprof.so
%{dynlib}/_md5module.so
%{dynlib}/_multibytecodecmodule.so
%{dynlib}/_multiprocessing.so
%{dynlib}/_randommodule.so
%{dynlib}/_sha256module.so
%{dynlib}/_sha512module.so
%{dynlib}/_shamodule.so
%{dynlib}/_socketmodule.so
%{dynlib}/_sqlite3.so
%{dynlib}/_ssl.so
%{dynlib}/_struct.so
%{dynlib}/_weakref.so
%{dynlib}/arraymodule.so
%{dynlib}/audioop.so
%{dynlib}/binascii.so
%{dynlib}/bz2.so
%{dynlib}/cPickle.so
%{dynlib}/cStringIO.so
%{dynlib}/cmathmodule.so
%{dynlib}/cryptmodule.so
%{dynlib}/datetime.so
%{dynlib}/dbm.so
%{dynlib}/dlmodule.so
%{dynlib}/fcntlmodule.so
%{dynlib}/future_builtins.so
%{dynlib}/gdbmmodule.so
%{dynlib}/grpmodule.so
%ifnarch x86_64
%{dynlib}/imageop.so
%endif
%{dynlib}/itertoolsmodule.so
%{dynlib}/linuxaudiodev.so
%{dynlib}/mathmodule.so
%{dynlib}/mmapmodule.so
%{dynlib}/nismodule.so
%{dynlib}/operator.so
%{dynlib}/ossaudiodev.so
%{dynlib}/parsermodule.so
%{dynlib}/pyexpat.so
%{dynlib}/readline.so
%{dynlib}/resource.so
%{dynlib}/selectmodule.so
%{dynlib}/spwdmodule.so
%{dynlib}/stropmodule.so
%{dynlib}/syslogmodule.so
%{dynlib}/termios.so
%{dynlib}/timemodule.so
%{dynlib}/timingmodule.so
%{dynlib}/unicodedata.so
%{dynlib}/xxsubtype.so
%{dynlib}/zlibmodule.so
%dir %{sitepkg}
%{sitepkg}/README
%ifarch x86_64
%dir %{_prefix}/lib/%{pkg}%{abi_ver}
%dir %{_prefix}/lib/%{pkg}%{abi_ver}/site-packages
%endif
%{_prefix}/lib/rpm/brp-multiple-python-bytecompile
%{_prefix}/lib/rpm/pythonmultideps.sh
%{_mandir}/man1/%{pkg}%{maj}%{min}.1*
%exclude %{pylib}/bsddb/test
%exclude %{pylib}/ctypes/test
%exclude %{pylib}/distutils/tests
%exclude %{pylib}/email/test
%exclude %{pylib}/json/tests
%exclude %{pylib}/lib2to3/tests
%exclude %{pylib}/sqlite3/test

%files devel
%defattr(-,root,root)
%doc Misc/{README.valgrind,gdbinit,setuid-prog.c,valgrind*.supp}
%{_bindir}/%{pkg}%{abi_ver}-config
%{_includedir}/%{pkg}%{abi_ver}/*.h
%{_libdir}/libpython*.so
%{pylib}/config/*
%exclude %{_includedir}/%{pkg}%{abi_ver}/%{_pyconfig_h}
%exclude %{pylib}/config/Makefile

%files libs
%defattr(-,root,root)
%doc LICENSE README
%{_libdir}/libpython*.so.*

%files static
%defattr(-,root,root)
%{_libdir}/libpython*.a

%files test
%defattr(-,root,root)
%{pylib}/bsddb/test
%{pylib}/ctypes/test
%{pylib}/distutils/tests
%{pylib}/email/test
%{pylib}/json/tests
%{pylib}/lib2to3/tests
%{pylib}/sqlite3/test
%{pylib}/test/*
%{dynlib}/_ctypes_test.so
%{dynlib}/_testcapimodule.so
%exclude %{pylib}/test/__init__.py*
%exclude %{pylib}/test/test_support.py*

%files tools
%defattr(-,root,root)
%doc Tools/{modulator,pynche}/README.*
%{_bindir}/2to3_*
%{_bindir}/idle*
%{_bindir}/modulator*
%{_bindir}/pynche*
%{_bindir}/msgfmt*.py*
%{_bindir}/pygettext*.py*
%{_bindir}/smtpd*.py*
%{sitepkg}/modulator
%{sitepkg}/pynche
%{tools}
%{demo}

%files -n %{tkinter}
%defattr(-,root,root)
%{pylib}/lib-tk
%{dynlib}/_tkinter.so


%changelog
* Mon Feb 02 2015 Peter Pramberger <peterpramb@member.fsf.org> - 2.6.9-2
- Added version-independent dependency generator for RPM

* Sat Mar 15 2014 Peter Pramberger <peterpramb@member.fsf.org> - 2.6.9-1
- Initial build
